//**********************************
//START: Equation Include Prototypes




//END: Equation Include Prototypes
//**********************************
#include "AR constants v10.h"
integer ARM_resourcesAvailable(integer resourceRequirementRecord, integer itemIndex)
{
	sysGlobalInt32 = AR_RESOURCESAVAILABLE_ACTIONTYPE;
	sysglobalInt30 = resourceRequirementRecord;
	sysglobalInt31 = itemIndex;
	sendMsgToBlock(sysGlobalInt33, BLOCKRECEIVE7MSG);
	return(sysGlobalInt36);
}
//__________________________________________________________________________
//
procedure ARM_changeResourceProperty(string resourceProperty, 
								     string propertyValue, 
									 string parentPropertyValue, 
									 integer updateNow)
{
	integer AdvancedResourcesDBIdx,
			ChangeResourcesTIdx,
			propertyFIdx,
			valueFIdx,
			parentValueFIdx;
	integer record, numChangeResourcesRecords;
	
	AdvancedResourcesDBIdx = DBDatabaseGetIndex("Advanced Resources");
	ChangeResourcesTIdx = DBTableGetIndex(AdvancedResourcesDBIdx, "Change Resources");
	propertyFIdx = DBFieldGetIndex(AdvancedResourcesDBIdx, ChangeResourcesTIdx, "Property");
	valueFIdx = DBFieldGetIndex(AdvancedResourcesDBIdx, ChangeResourcesTIdx, "Value");
	parentValueFIdx = DBFieldGetIndex(AdvancedResourcesDBIdx, ChangeResourcesTIdx, "Parent Value");

	numChangeResourcesRecords = DBRecordsGetNum(AdvancedResourcesDBIdx, ChangeResourcesTIdx);
	for (record=1;record<=numChangeResourcesRecords;record++)
	{
		if (DBDataGetAsString(AdvancedResourcesDBIdx, ChangeResourcesTIdx, propertyFIdx, record) == resourceProperty)
		{
		//	Set the value of the selected resource's ID
			DBDataSetAsString(AdvancedResourcesDBIdx, ChangeResourcesTIdx, valueFIdx, record, propertyValue);
			DBDataSetAsString(AdvancedResourcesDBIdx, ChangeResourcesTIdx, parentValueFIdx, record, parentPropertyValue);
			break;
		}
	}

	if (updateNow)
	{
		sysGlobal14 = DBAddressCreate(AdvancedResourcesDBIdx, ChangeResourcesTIdx, 1, 1);
		sysGlobalInt32 = 7;	// change resources
		sendMsgToBlock(sysGLobalInt33, BLOCKRECEIVE7MSG);
	}
}
//________________________________________________________________
//
string ARM_getAllocatedResourcePropertyValue(real allocatedResDBA, string whichProperty, integer whichResource)
{
	integer databaseIndex, allocatedResourcesTableIndex;
	integer AdvancedResourcesDBIdx, ResourcesTIdx, propertyFIdx;
	integer numRecords, resourceRecord;
	string propertyValue;
	
	databaseIndex = DBDatabaseGetIndexFromAddress(allocatedResDBA);
	allocatedResourcesTableIndex = DBTableGetIndexFromAddress(allocatedResDBA);
	numRecords = DBRecordsGetNum(databaseIndex, allocatedResourcesTableIndex);
	if ((whichResource <= numRecords) && (whichResource >= 1))
	{
		resourceRecord = DBDataGetAsNumber(databaseIndex, allocatedResourcesTableIndex, 1, whichResource);
		AdvancedResourcesDBIdx = DBDatabaseGetIndex("Advanced Resources");
		ResourcesTIdx = DBTableGetIndex(AdvancedResourcesDBIdx, "Resources");
		propertyFIdx = DBFieldGetIndex(AdvancedResourcesDBIdx, ResourcesTIdx, whichProperty);
		if (propertyFIdx > 0)
		{
			propertyValue = DBDataGetAsString(AdvancedResourcesDBIdx, ResourcesTIdx, propertyFIdx, resourceRecord);
			return(propertyValue);
		}
		else
		{
			userError("ERROR: ARM_getAllocatedResourcePropertyValue - Invalid resource property value = " + whichProperty);
			AbortAllSims();
		}
	}
	else
	{
		userError("ERROR: ARM_getAllocatedResourcePropertyValue - Specified allocated resource " + whichResource + " is out of range. There are " + numRecords + " allocated resources in the specified allocated resource table");
		AbortAllSims();
	}
}
//________________________________________________________________
//
integer ARM_getAllocatedResourceRecord(real allocatedResDBA, integer whichResource)
{
	integer databaseIndex, allocatedResourcesTableIndex;
	integer AdvancedResourcesDBIdx, ResourcesTIdx, propertyFIdx;
	integer numRecords, resourceRecord;
	string propertyValue;
	
	databaseIndex = DBDatabaseGetIndexFromAddress(allocatedResDBA);
	allocatedResourcesTableIndex = DBTableGetIndexFromAddress(allocatedResDBA);
	numRecords = DBRecordsGetNum(databaseIndex, allocatedResourcesTableIndex);
	if ((whichResource <= numRecords) && (whichResource >= 1))
	{
		resourceRecord = DBDataGetAsNumber(databaseIndex, allocatedResourcesTableIndex, 1, whichResource);
		return(resourceRecord);
	}
	else
	{
		userError("ERROR: ARM_getAllocatedResourceRecord - Specified allocated resource " + whichResource + " is out of range. There are " + numRecords + " allocated resources in the specified allocated resource table");
		AbortAllSims();
	}
}

